<div class="container-fluid mt-0 mb-5 pl-0 pr-0">
  <form #dataValidationListForm="ngForm">
    <ejs-grid #dataValidationListGrid [dataSource]="dataValidationRules 
     | filter:searchtxt:['data_layer_name', 'obj_nm', 'attr_nm_lst', 'bk_attr_nm_lst', 'visual_rule_desc', 'rule_desc']
     | arrayFilter:layerToFilter:['data_layer_id']:filterMetadata 
     | arrayFilter:objToFilter:['obj_id']:filterMetadata 
     | arrayFilter:attrToFilter:['attr_id_lst']:filterMetadata 
     | arrayFilter:ruleToFilter:['mstr_rule_id']:filterMetadata
     | arrayFilter:statusToFilter:['is_rule_actv']:filterMetadata
     | arrayFilter:severityToFilter:['rule_svrt']:filterMetadata" (dataBound)="onDVListGridDataBound()"
      [allowPaging]="true" [allowSorting]="true" [showColumnChooser]="true" [toolbar]="gridToolbar"
      [pageSettings]="gridPageSettings" [allowTextWrap]="true">
      <e-columns>
        <e-column type='checkbox' [allowFiltering]='false' [allowSorting]='false' width='60'></e-column>
        <e-column field="data_layer_name" headerText={{dataValidationFormContent.ruleListColumn.objLayerNm}}>
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.data_layer_name}}">
              {{dataValidationRules.data_layer_name !== null && dataValidationRules.data_layer_name?.length > 25 ? dataValidationRules.data_layer_name.slice(0,25).concat("...") : dataValidationRules.data_layer_name}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="obj_nm" headerText={{dataValidationFormContent.ruleListColumn.objNm}}>
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.obj_nm}}">
              {{dataValidationRules.obj_nm !== null && dataValidationRules.obj_nm?.length > 25 ? dataValidationRules.obj_nm.slice(0,25).concat("...") : dataValidationRules.obj_nm}}
            </span>
          </ng-template>
        </e-column>
        <!-- <e-column field="attr_nm_lst" headerText={{dataValidationFormContent.ruleListColumn.attrName}}></e-column>  -->
        <e-column field="attr_nm_lst" title="attr_nm_lst"
          headerText="{{dataValidationFormContent.ruleListColumn.attrName}}">
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.attr_nm_lst}}">
              {{dataValidationRules.attr_nm_lst !== null && dataValidationRules.attr_nm_lst?.length > 25 ? dataValidationRules.attr_nm_lst.slice(0,25).concat("...") : dataValidationRules.attr_nm_lst}}
            </span>
          </ng-template>
        </e-column>
        <!-- <e-column field="visual_rule_desc" headerText={{dataValidationFormContent.ruleListColumn.visualDescription}}>
        </e-column> -->
        <e-column field="visual_rule_desc" title="visual_rule_desc"
          headerText="{{dataValidationFormContent.ruleListColumn.visualDescription}}">
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.visual_rule_desc}}">
              {{dataValidationRules.visual_rule_desc !== null && dataValidationRules.visual_rule_desc?.length > 25 ? dataValidationRules.visual_rule_desc.slice(0,25).concat("...") : dataValidationRules.visual_rule_desc}}
            </span>
          </ng-template>
        </e-column>
        <!-- <e-column field="bk_attr_nm_lst" headerText={{dataValidationFormContent.ruleListColumn.bkAttrName}}></e-column> -->
        <e-column field="bk_attr_nm_lst" title="bk_attr_nm_lst"
          headerText="{{dataValidationFormContent.ruleListColumn.bkAttrName}}">
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.bk_attr_nm_lst}}">
              {{dataValidationRules.bk_attr_nm_lst !== null && dataValidationRules.bk_attr_nm_lst?.length > 25 ? dataValidationRules.bk_attr_nm_lst.slice(0,25).concat("...") : dataValidationRules.bk_attr_nm_lst}}
            </span>
          </ng-template>
        </e-column>
        <!-- <e-column field="rule_desc" headerText={{dataValidationFormContent.ruleListColumn.ruleDescription}}>
        </e-column> -->
        <e-column field="rule_desc" title="rule_desc"
          headerText="{{dataValidationFormContent.ruleListColumn.ruleDescription}}">
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.rule_desc}}">
              {{dataValidationRules.rule_desc !== null && dataValidationRules.rule_desc?.length > 25 ? dataValidationRules.rule_desc.slice(0,25).concat("...") : dataValidationRules.rule_desc}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="is_rule_actv" headerText="{{dataValidationFormContent.ruleListColumn.isActive}}" width='100'
          class="justify-content-center">
          <ng-template #template let-dataValidationRules>
            <div class="switch">
              {{dataValidationRules.is_rule_actv?'Yes':''}}
              <ejs-switch [checked]="dataValidationRules.is_rule_actv" [disabled]="true"></ejs-switch>
              {{dataValidationRules.is_rule_actv?'':'No'}}
            </div>
          </ng-template>
        </e-column>
        <e-column field="rule_svrt" headerText={{dataValidationFormContent.ruleListColumn.ruleSvrt}} width='130'>
          <ng-template #template let-dataValidationRules>
            <span title="{{dataValidationRules.rule_svrt}}">
              {{dataValidationRules.rule_svrt !== null && dataValidationRules.rule_svrt?.length > 25 ? dataValidationRules.rule_svrt.slice(0,25).concat("...") : dataValidationRules.rule_svrt}}
            </span>
          </ng-template>
        </e-column>
        <e-column headerText={{dataValidationFormContent.ruleListColumn.editCommands}} [commands]="gridCommands"
          width='85' textAlign="Center"></e-column>
      </e-columns>
    </ejs-grid>
  </form>
  <span class="d-flex float-right top-minus-42" id="customPagerTemplate">
    <span class="text-dark ml-5 mr-2 mt-2 pt-1">Results Per Page</span>
    <span class="mt-1">
      <ejs-dropdownlist name="pageSize" cssClass="e-outline" [dataSource]="['All', '5', '10', '20', '30', '50', '100']"
        value="5" (change)="changePageSize($event)" width="75px">
      </ejs-dropdownlist>
    </span>
  </span>
</div>
<span *ngIf="active">
  <span id="showDVResultsCount" class="top-minus-5">
    <!-- <span class="text-muted">1-{{filterMetadata.count > numberOfDVRules*currentPage ? numberOfDVRules*currentPage  : filterMetadata.count }} of {{filterMetadata.count}}</span> -->
    <span
      class="text-muted">{{(dataValidationListGrid.pageSettings.currentPage-1)*dataValidationListGrid.pageSettings.pageSize+1}}
      -
      {{filterMetadata.count > dataValidationListGrid.pageSettings.currentPage*dataValidationListGrid.pageSettings.pageSize ? dataValidationListGrid.pageSettings.currentPage*dataValidationListGrid.pageSettings.pageSize : filterMetadata.count}}</span>
  </span>
  <span id="addDVRuleTemplate" class="mr-0 top-minus-5">
    <button class="iconTextButton btn btn-primary" data-ripple="true" aria-label="Add New Data Validation Rule">
      <!-- <em class="fa fa-plus fa-fw mr-2"></em> -->
      <img src="assets/images/novartis/add.svg" alt="Add New Rule" />{{dataQualityContent.addNewRule}}</button>
  </span>
  <span id="exportDVTemplate" class="mr-1 top-minus-5">
    <button class="iconButton btn btn-primary" data-ripple="true" aria-label="Export Data Validation Rules">
      <!-- <em class="fa fa-upload fa-fw"></em> -->
      <img src="assets/images/novartis/upload.svg" alt="Import Rules" />
    </button>
  </span>
  <span id="columnChooserTemplateDV" class=" mr-0 top-minus-8">
    <button class="iconButton btn btn-primary" data-ripple="true" aria-label="Choose Columns To be Displayed">
      <!-- <em class="fa fa-columns fa-fw"></em> -->
      <img src="assets/images/novartis/column.svg" alt="Choose Columns" />
    </button>
  </span>
</span>
<ejs-dialog #addNewDataValidationRuleDialog
  [header]="isRuleEditMode?dataValidationFormContent.dialogForm.editRuleHeader:dataValidationFormContent.dialogForm.addRuleHeader"
  [buttons]="dlgButtons" [visible]="false" class="data-validation" [isModal]="true" [position]="dlgPosition"
  showCloseIcon="true" [animationSettings]="dlgAnimationSettings" (close)="modalDlgClose()">
  <ng-template #content>
    <app-data-validation-form #dataValidationFormComponent (latestRuleIdEmitter)="updateLatestRuleId($event)">
    </app-data-validation-form>
  </ng-template>
</ejs-dialog>